
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */


#include "polygraph.h"

#include <iostream.h>

#include "BStream.h"


/* BinIos */

BinIos::~BinIos() {
}

/* IBStream */

IBStream::IBStream(): theStream(0) {
}

IBStream::~IBStream() {
}

void IBStream::configure(istream *aStream, const String &aName) {
	Assert(!theStream && aStream);
	theStream = aStream;
	theName = aName;
}

String &IBStream::gets(String &s) {
	const int sz = geti();
        Must(sz >= 0);
        s.alloc(sz);
        if (sz)
                get(s.buf(), sz);
        return s;
}


/* OBStream */

OBStream::OBStream(): theStream(0) {
}

OBStream::~OBStream() {
}

void OBStream::configure(ostream *aStream, const String &aName) {
	Assert(!theStream && aStream);
	theStream = aStream;
	theName = aName;
}

void OBStream::put(const void *buf, Size size) {
	Assert(theStream);
	theStream->write(buf, size);
}

void BStream::configure(iostream *aStream, const String &aName) {
	IBStream::configure(aStream, aName);
	OBStream::configure(aStream, aName);
}
