
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_ERROR_STATISTICS_H
#define PG_ERROR_STATISTICS_H

#include "Array.h"
#include "LogObj.h"

class String;
class ErrorStrTbl;

// detailed error histogram
// see ErrorStrTbl for error strings
class ErrorStat: public Array<int>, public LogObj {
	public:
		ErrorStat(int maxErrNo = 0);

		void reset();
		void maxErrNo(int max);
		
		int maxErrNo() const;
		int totalErrCnt() const;

		void record(int errNo);

		void add(const ErrorStat &s);
		ErrorStat &operator =(const ErrorStat &es);

		virtual OLog &store(OLog &ol) const;
		virtual ILog &load(ILog &il);

		ostream &print(ostream &os, const ErrorStrTbl &tbl, const String &pfx) const;
};

#endif
