
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_ERROR_STRING_TABLE_H
#define PG_ERROR_STRING_TABLE_H

#include "Array.h"
#include "String.h"
#include "LogObj.h"


// holds explanatory strings for errnos
class ErrorStrTbl: public LogObj, protected Array<String*> {
	public:
		ErrorStrTbl(); // will add "system" error strings
		virtual ~ErrorStrTbl();

		int maxErrNo() const;
		const String &operator [](int errNo) const;

		virtual OLog &store(OLog &ol) const;
		virtual ILog &load(ILog &il);

		ErrorStrTbl &operator =(const ErrorStrTbl &est);

	protected:
		void reset();
		String &str(int errNo);

	private:
		void fillUpTo(int lastIdx);

	private:
		String theErrnoErrStr; // returned for bad errnos
};

#endif
