
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include <iostream.h>
#include <iomanip.h>

#include "OLog.h"
#include "ILog.h"
#include "Oid.h"
#include "ObjId.h"


ObjId::ObjId(const OidRec &r): 
	theWorld(r.wid), theServer(r.hidx), theType(r.tid), theName(r.oid) {
}

void ObjId::reset() {
	theWorld.clear();
	theServer = theType = theName = -1;
	// check that ObjId(const OidRec &r) is in sync
}

int ObjId::hash() const {
	return abs(theWorld.hash() * theServer + theName);
}

void ObjId::store(OLog &ol) const {
	ol << theWorld << theServer << theType << theName;
}

void ObjId::load(ILog &il) {
	il >> theWorld >> theServer >> theType >> theName;
}
