
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "ILog.h"
#include "OLog.h"
#include "TmSzHistStat.h"


TmSzHistStat::TmSzHistStat() {
	reset();
}

void TmSzHistStat::reset() {
	theTm.reset();
	theSz.reset();
}

OLog &TmSzHistStat::store(OLog &log) const {
	return log << theTm << theSz;
}

ILog &TmSzHistStat::load(ILog &log) {
	return log >> theTm >> theSz;
}

TmSzHistStat &TmSzHistStat::operator +=(const TmSzHistStat &ts) {
	theTm += ts.theTm;
	theSz += ts.theSz;
	return *this;
}

ostream &TmSzHistStat::print(ostream &os, const String &pfx) const {
	theTm.print(os, pfx + "rptm.");
	theSz.print(os, pfx + "size.");
	return os;
}
