
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl.h"

#include "PglRec.h"
#include "PglIntSym.h"
#include "PglSizeSym.h"
#include "CacheSym.h"


CacheSym::CacheSym(): RecSym("Cache", new PglRec) {
	theRec->bAdd("size", "capacity", 0);
	theRec->bAdd("int", "icp_port", 0);
}

CacheSym::CacheSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
}

bool CacheSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "Cache";
}

SynSym *CacheSym::clone(const String &type) const {
	if (isA(type))
		return new CacheSym(this->type(), theRec->clone());
	return RecSym::clone(type);
}

bool CacheSym::capacity(BigSize &cap) const {
	return getSize("capacity", cap);
}

bool CacheSym::icpPort(int &port) const {
	return getInt("icp_port", port);
}
