
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl.h"

#include "Assert.h"
#include "String.h"
#include "Rnd.h"
#include "PglQualifSym.h"
#include "PglDistrSym.h"


// XXX: we are leaking actual distributions as they are never deleted!

DistrSym::DistrSym(const String &aType, RndDistr *aVal): 
	ExpressionSym(aType), theVal(aVal), theQual(0) {
}

DistrSym::~DistrSym() {
	delete theQual;
}

bool DistrSym::isA(const String &type) const {
	return ExpressionSym::isA(type) || type == "Distr";
}

SynSym *DistrSym::clone(const String &type) const {
	if (isA(type)) {
		DistrSym *d = new DistrSym(this->type(), theVal);
		d->qualifier(theQual, theQfOp);
		return d;
	}
	return ExpressionSym::clone(type);
}

void DistrSym::qualifier(const QualifSym *aQual, const String &anOp) {
	delete theQual;
	theQual = aQual ? (QualifSym*)aQual->dup() : 0;
	theQfOp = anOp;
}

ostream &DistrSym::print(ostream &os, const String &) const {
	if (theQual)
		theQual->print(os) << theQfOp;
	if (theVal)
		theVal->print(os);
	else
		os << "<none>";
	return os;
}
