
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_NUM_EXPRESSION_SYMBOL_H
#define PGL_NUM_EXPRESSION_SYMBOL_H

#include "PglExprSym.h"

// floating point "number"

class NumSym: public ExpressionSym {
	public:
		NumSym(double aVal);

		double val() const { return theVal; }
		void val(double v) { theVal = v; }

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		double theVal;
};

#endif
