
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef POLYGRAPH_PGL_PP_H
#define POLYGRAPH_PGL_PP_H

#include "Array.h"
#include "Lexer.h"

class String;
class istream;
class GLexer;

// PGL preprocessor

class PglPp: public Lexer {
	public:
		PglPp(const String &fname);
		virtual ~PglPp();

	protected:
		virtual LexToken scan();
		void advance();

		GLexer *lexer() { return theLexers[theDepth-1]; }
		const GLexer *lexer() const { return theLexers[theDepth-1]; }

		bool filtered();
		void ignoreLineCmnt();
		void ignoreBlockCmnt();
		void ppdInclude();
		void ppDirective();
		void system();

		void open(const String &fname);
		void popen(const String &cmd);
		void open(istream &is, const String &fname);
		void close();

		void printLexers(ostream &os) const;

	public:
		static Array<String*> TheDirs;
	
	protected:
		GLexer *theLexers[256]; // replace with Array
		int theDepth;           // nesting depth
};

#endif
