
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_RATE_SYMBOL_H
#define PGL_RATE_SYMBOL_H

#include "Time.h"
#include "PglExprSym.h"

class TimeSym;
class SizeSym;
class NumSym;

// rate [objects/time]

class RateSym: public ExpressionSym {
	public:
		RateSym(double aCount, Time AnInterval);
		RateSym(double aVal);

		double val() const; // [obj/sec]
		void val(double aVal); // [obj/sec]
		//void val(double aCount, Time AnInterval);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		ExpressionSym *operRR(const String &op, RateSym *rs, const SynSym &s) const;
		ExpressionSym *operRT(const String &op, TimeSym *ts, const SynSym &s) const;
		ExpressionSym *operRS(const String &op, SizeSym *ss, const SynSym &s) const;
		ExpressionSym *operRN(const String &op, NumSym *ns, const SynSym &s) const;

	protected:
		double theCount;
		Time theInterval;
};

#endif
