
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_STRING_SYMBOL_H
#define PGL_STRING_SYMBOL_H

#include "PglExprSym.h"

class String;

// a string

class StringSym: public ExpressionSym {
	public:
		StringSym(const String &aVal): ExpressionSym("string"), theVal(aVal) {}

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		const String &val() const { return theVal; }

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		String theVal;
};

#endif
