
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_ROBOT_SYMBOL_H
#define PG_ROBOT_SYMBOL_H

#include "Array.h"
#include "AgentSym.h"

class String;
class PopModelSym;
class RndDistr;


// server side configuration
class RobotSym: public AgentSym {
	public:
		RobotSym();
		RobotSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		RndDistr *reqInterArrival() const;
		bool publicRatio(double &ratio) const;
		bool recurRatio(double &ratio) const;
		bool embedRecurRatio(double &ratio) const;
		PopModelSym *popModel() const;
		bool uniqueUrls(bool &set) const;
		Time launchWin() const;
		bool openConnLimit(int &lmt) const;
		bool waitXactLimit(int &lmt) const;
		bool icpPort(int &port) const;
		NetAddr peerHttp() const;
		NetAddr peerIcp() const;
		bool privCache(int &capacity) const;
		bool origins(Array<NetAddr*> &addrs) const;
		bool origins(Array<NetAddr*> &addrs, RndDistr *&sel) const;
		RndDistr *reqTypes(const Array<String*> &typeNames) const;

	protected:
		bool reqRate(double &rate) const;
};

#endif
