
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "Clock.h"
#include "ErrorMgr.h"
#include "IcpXaction.h"

#include "polyBcastChannels.h"
#include "polyErrors.h"
#include "polyLogCats.h"


void IcpXaction::reset() {
	theAddr = NetAddr();
	theOid.reset();
	theStartTime = theLifeTime = Time();
	theRepSize = Size();
	theResult = icpInvalid;
	theLogCat = lgcAll;
}

void IcpXaction::start() {
	theStartTime = TheClock;
}

void IcpXaction::finish(int errNo) {
	theLifeTime = TheClock - theStartTime;

	if (errNo) {
		theResult = icpInvalid;
		if (errNo != -1)
			ReportError(errNo);
	} else {
		Broadcast(TheIcpXactEndChannel, this);
	}
}
