
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "xstd.h"

#include <string.h>
#include <iostream.h>

#include "Assert.h"

const char *error::str() const {
	return strerror(theErrNo);
}

ostream &error::print(ostream &os) const {
	return os << '(' << theErrNo << ") " << str();
}

void Complain(const char *fname, int lineno) {
	cerr << fname << ':' << lineno << ": " << error(errno) << endl;
}


void Abort(const char *fname, int lineno, const char *cond) {
	cerr << fname << ':' << lineno << ": assertion failed: '" 
		<< (cond ? cond : "?") << "'" << endl;
	::abort();
}

void Exit(const char *fname, int lineno, const char *cond) {
	cerr << fname << ':' << lineno << ": assertion failed: '" 
		<< (cond ? cond : "?") << "'" << endl;
	::exit(-2);
}
