
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "xstd.h"

#include <sys/types.h>
#include <arpa/inet.h>
#include <iostream.h>

#include "NetAddr.h"

NetAddr NetAddr::MakeAddr(unsigned long net, unsigned long lna, int port) {
	return NetAddr(inet_makeaddr(net, lna), port);
}

unsigned long NetAddr::lna() const {
	return inet_lnaof(addrN());
}

unsigned long NetAddr::net() const {
	return inet_netof(addrN());
}

void NetAddr::syncA() const {
	theAddrA = theAddrN.s_addr == INADDR_NONE ?
		0 : inet_ntoa(theAddrN);
}

void NetAddr::syncN() const {
	if (theAddrA)
		theAddrN.s_addr = inet_addr(theAddrA);
	else
		theAddrN.s_addr = INADDR_NONE;
}

bool NetAddr::operator == (const NetAddr &addr) const {
	if (thePort != addr.thePort)
		return false;

	if (theAddrN.s_addr != INADDR_NONE && addr.theAddrN.s_addr != INADDR_NONE)
		return theAddrN.s_addr == addr.theAddrN.s_addr;

	return theAddrA == addr.theAddrA;
}

ostream &NetAddr::print(ostream &os) const {
	if (addrA())
		os << theAddrA;
	else
	if (thePort >= 0)
		os << '*';
	else
		os << "<none>";

	if (thePort >= 0)
		os << ':' << thePort;

	return os;
}
