
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef XSTD_FIX_POLL_H
#define XSTD_FIX_POLL_H

#ifdef HAVE_POLL
#include <poll.h>

/* Linux does not define "NORM" */
#ifndef POLLRDNORM
#define POLLRDNORM POLLIN
#endif
#ifndef POLLWRNORM
#define POLLWRNORM POLLOUT
#endif

inline
int xpoll(pollfd *fds, unsigned int nfds, int timeout) {
	return ::poll(fds, nfds, timeout);
}

#else

#define POLLRDNORM 1
#define POLLWRNORM 2
#define POLLERR 4
#define POLLHUP 8
#define POLLNVAL 16

struct pollfd { int fd;  short events; short revents; };
extern int xpoll(pollfd *fds, unsigned int nfds, int timeout);

#endif


#endif
